/*
 *      ISIS release V1.1, Dec. 1988
 *      Export restrictions apply
 */
#include "isis.h"

static  adesc   gi_ad = { sizeof(ginfo), 0, 2 };

static ginfo *
gi_alloc()
  {
        register ginfo *gip = ((ginfo*)mallocate(&gi_ad));
        gip->gi_gaddr = NULLADDRESS;
        *gip->gi_gname = 0;
        gip->gi_join_verifier = NULLROUTINE;
        gip->gi_client_verifier = NULLROUTINE;
        gip->gi_lnode = 0;
        bclr(gip->gi_lentries);
        bcopy(def_xfer_rcv, gip->gi_xfer_rcv, sizeof(def_xfer_rcv));
        bcopy(def_xfer_gen, gip->gi_xfer_gen, sizeof(def_xfer_gen));
        gip->gi_xbyref = 0;
        gip->gi_next = isis_groups;
        gip->gi_clwatchq = qu_null();
        gip->gi_clwatchq->qu_viewid = 0;
        gip->gi_protosview = gip->gi_bypassview = gip->gi_mutexview = gip->gi_view = 0;
        gip->gi_bypasswait = 0;
	gip->gi_myseqn = 0;
	gip->gi_departed = -1;
        gip->gi_guarded = qu_null();
        gip->gi_pats = qu_null();
        gip->gi_events = qu_null();
        gip->gi_bypassq = qu_null();
        gip->gi_byprocs = qu_null();
        gip->gi_bypasscount = gip->gi_bypassviewid = 0;
        bzero(gip->gi_bseqns, sizeof(gip->gi_bseqns));
        isis_groups = gip;
        return(gip);
  }

gi_free(gip)
  register ginfo *gip;
  {
        qu_freeall(gip->gi_guarded);
        qu_freeall(gip->gi_pats);
        qu_freeall(gip->gi_events);
        if(qu_head(gip->gi_bypassq))
            panic("gi_free: bypassq not empty");
        qu_free(gip->gi_bypassq);
        if(gip->gi_mutexview)
            isis_gv_free(gip->gi_mutexview);
        if(gip->gi_view)
            isis_gv_free(gip->gi_view);
        mdeallocate((char*)gip,&gi_ad);
  }

ginfo *
map_gname(gname)
  register char *gname;
  {
        register ginfo *gip;
        if(*gname == '@')
            while(*++gname && *gname != ':')
                continue;
        for(gip = isis_groups; gip; gip = gip->gi_next)
            if(strcmp(gip->gi_gname, gname) == 0)
                return(gip);
        return((ginfo*)0);
  }

ginfo *
map_gaddr(gaddr)
  address gaddr;
  {
        register ginfo *gip;
        gaddr.entry = 0;
        for(gip = isis_groups; gip; gip = gip->gi_next)
            if(addr_isequal(gaddr, gip->gi_gaddr))
                return(gip);
        return((ginfo*)0);
  }

ginfo *
add_gname(gname)
  register char *gname;
  {
        register ginfo *gip;
        if(*gname == '@')
            while(*++gname && *gname != ':')
                continue;
        if((gip = map_gname(gname)) == (ginfo*)0)
        {
            gip = gi_alloc();
            strcpy(gip->gi_gname, gname);
        }
        return(gip);
  }

ginfo *
add_group(gname, gaddr)
  char *gname;
  address gaddr;
  {
        register ginfo *gip;
        for(gip = isis_groups; gip; gip = gip->gi_next)
            if(addr_isequal(gaddr, gip->gi_gaddr))
                break;
            else if(strcmp(gip->gi_gname, gname) == 0)
                break;
        if(gip == (ginfo*)0)
            gip = gi_alloc();
        gip->gi_gaddr = gaddr;
        strcpy(gip->gi_gname, gname);
        return(gip);
  }

/* Only called if a join fails */
group_unmap(gip)
  register ginfo *gip;
  {
        register ginfo *gop = 0, *gjp;
        for(gjp = isis_groups; gjp; gjp = gjp->gi_next)
            if(gjp == gip)
                break;
            else
                gop = gjp;
        if(gjp == (ginfo*)0)
            panic("group_unmap: gip %x not found", gip);
        if(gop)
            gop->gi_next = gip->gi_next;
        else
            isis_groups = gip->gi_next;
        gi_free(gip);
  }

static adesc gv_ad ={ sizeof(groupview), 0, 8};

#define	gv_allocate()		((groupview*)mallocate(&gv_ad))
#define	gv_deallocate(gv)	mdeallocate((char*)gv, &gv_ad)

groupview *
isis_gv_alloc()
  {
	register groupview *gv;
	gv = gv_allocate();
	gv->gv_flag = 0;
	gv->gv_refcount = 1;
	return(gv);
  }

isis_gv_free(gv)
  register groupview *gv;
  {
	if(--gv->gv_refcount == 0)
	    gv_deallocate(gv);
  }
